/**
 * crypto.h
 */

#ifndef __WII_CRYPTO_H__
#define __WII_CRYPTO_H__

#include "types.h"
#include "wii_tik.h"

void get_common_key(u8 *key);

void md5(u8 *data, u32 len, u8 *hash);
void sha(u8 *data, u32 len, u8 *hash);
void aes_cbc_dec(u8 *key, u8 *iv, u8 *in, u32 len, u8 *out);
void aes_cbc_enc(u8 *key, u8 *iv, u8 *in, u32 len, u8 *out);
void decrypt_title_key(wii_tik *tik, u8 *title_key);

#endif
